/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jpa;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author lacomme
 */
@Entity
@Table(name = "auteur")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Auteur.findAll", query = "SELECT a FROM Auteur a"),
    @NamedQuery(name = "Auteur.findByNumeroA", query = "SELECT a FROM Auteur a WHERE a.numeroA = :numeroA"),
    @NamedQuery(name = "Auteur.findByNom", query = "SELECT a FROM Auteur a WHERE a.nom = :nom"),
    @NamedQuery(name = "Auteur.findByPrenom", query = "SELECT a FROM Auteur a WHERE a.prenom = :prenom"),
    @NamedQuery(name = "Auteur.findByDomicile", query = "SELECT a FROM Auteur a WHERE a.domicile = :domicile")})
public class Auteur implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Column(name = "NUMERO_A")
    private Integer numeroA;
    @Size(max = 45)
    @Column(name = "NOM")
    private String nom;
    @Size(max = 45)
    @Column(name = "PRENOM")
    private String prenom;
    @Size(max = 45)
    @Column(name = "DOMICILE")
    private String domicile;
    @OneToMany(mappedBy = "numeroA")
    private transient List<Livre> livreList;

    public Auteur() {
    }

    public Auteur(Integer numeroA) {
        this.numeroA = numeroA;
    }

    public Integer getNumeroA() {
        return numeroA;
    }

    public void setNumeroA(Integer numeroA) {
        this.numeroA = numeroA;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public String getPrenom() {
        return prenom;
    }

    public void setPrenom(String prenom) {
        this.prenom = prenom;
    }

    public String getDomicile() {
        return domicile;
    }

    public void setDomicile(String domicile) {
        this.domicile = domicile;
    }

    @XmlTransient
    public List<Livre> getLivreList() {
        return livreList;
    }

    public void setLivreList(List<Livre> livreList) {
        this.livreList = livreList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (numeroA != null ? numeroA.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Auteur)) {
            return false;
        }
        Auteur other = (Auteur) object;
        if ((this.numeroA == null && other.numeroA != null) || (this.numeroA != null && !this.numeroA.equals(other.numeroA))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "jpa.Auteur[ numeroA=" + numeroA + " ]";
    }
    
}
