/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jpa;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author lacomme
 */
@Entity
@Table(name = "livre")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Livre.findAll", query = "SELECT l FROM Livre l"),
    @NamedQuery(name = "Livre.findByNumeroL", query = "SELECT l FROM Livre l WHERE l.numeroL = :numeroL"),
    @NamedQuery(name = "Livre.findByTitre", query = "SELECT l FROM Livre l WHERE l.titre = :titre"),
    @NamedQuery(name = "Livre.findByPrix", query = "SELECT l FROM Livre l WHERE l.prix = :prix")})
public class Livre implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Column(name = "NUMERO_L")
    private Integer numeroL;
    @Size(max = 45)
    @Column(name = "TITRE")
    private String titre;
    @Column(name = "PRIX")
    private Integer prix;
    @JoinColumn(name = "NUMERO_A", referencedColumnName = "NUMERO_A")
    @ManyToOne
    private transient Auteur numeroA;

    public Livre() {
    }

    public Livre(Integer numeroL) {
        this.numeroL = numeroL;
    }

    public Integer getNumeroL() {
        return numeroL;
    }

    public void setNumeroL(Integer numeroL) {
        this.numeroL = numeroL;
    }

    public String getTitre() {
        return titre;
    }

    public void setTitre(String titre) {
        this.titre = titre;
    }

    public Integer getPrix() {
        return prix;
    }

    public void setPrix(Integer prix) {
        this.prix = prix;
    }

    public Auteur getNumeroA() {
        return numeroA;
    }

    public void setNumeroA(Auteur numeroA) {
        this.numeroA = numeroA;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (numeroL != null ? numeroL.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Livre)) {
            return false;
        }
        Livre other = (Livre) object;
        if ((this.numeroL == null && other.numeroL != null) || (this.numeroL != null && !this.numeroL.equals(other.numeroL))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "jpa.Livre[ numeroL=" + numeroL + " ]";
    }
    
}
